<?php

class Tx_Mymap_ViewHelpers_MapJSViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper {
    /**
    * Returns the map javascript
    *
    * @param mixed $locations
    * @param string $city
    * @param mixed $settings
    * @return string
    */
    public function render($locations, $city, $settings) {
		if ($settings['enableMarkerAnimation']) 
			$animation = 'animation: google.maps.Animation.DROP,';
		else $animation = '';

		$out = $this->getMapJavascript($locations, $settings);
		
		$out .= '<script type="text/javascript">
            function getMarkers() {';
            for ($i = 0; $i < count($locations); $i++) {
                $lat = $locations[$i]['lat'];
                $lon = $locations[$i]['lon'];
                
                $out .= 'var myLatLng = new google.maps.LatLng(' . $lat. ',' . $lon .');';
                $out .= 'var shadow = new google.maps.MarkerImage("typo3conf/ext/mymap/Resources/Public/Icons/shadow.png",
                                        // The shadow image is larger in the horizontal dimension
                                        // while the position and offset are the same as for the main image.
                                        new google.maps.Size(37, 37),
                                        new google.maps.Point(0,0),
                                        new google.maps.Point(10, 37));';
    
    
                if ($locations[$i]['icon']) {
                $out .= 'marker[' . $i . '] = new google.maps.Marker({
                                        position: myLatLng,
                                        map: map,
                                        title: "' . $locations[$i]['name'] .'",
                                        icon: "/uploads/tx_mymap/icons/' . $locations[$i]['icon'] .'",
										' . $animation . '
//    animation: google.maps.Animation.DROP,
                                        shadow: shadow
                                        });
                                        mapBounds.extend(myLatLng);
    
                                        ';
                
                
                } else {
    
                $out .= 'marker[' . $i . '] = new google.maps.Marker({
                                        position: myLatLng,
                                        map: map,
                                        title: "' . $locations[$i]['name'] .'",
                                        icon: "/typo3conf/ext/mymap/Resources/Public/Icons/pointerBlue.png",
									' . $animation . '
//    animation: google.maps.Animation.DROP,
                                        shadow: shadow
                                        });
                                        mapBounds.extend(myLatLng);
    
                                        ';
                }
    
    /*
                $out .= "
                    var contentString ='" . addslashes($locations[$i]['name']) . '<br />' . addslashes($locations[$i]['address']) . '<br />' . 
                        addslashes($locations[$i]['zipcode']) . ' ' . addslashes($locations[$i]['city']) ."';
                    infoWindow[$i] = new google.maps.InfoWindow({
                      content: contentString
                  });
                    google.maps.event.addListener(marker[$i], 'click', function() {
                    infoWindow[$i].open(map,marker[$i]);
                });";
    */
    
            }
            $out .= '}</script>';
		return $out;
	 }
	 
	 function getMapJavascript($locations, $settings) {
        $out = '<script type="text/javascript">
        var myOptions;
        var marker = [];
        var infoWindow = [];
        var map;
        var mapBounds = new google.maps.LatLngBounds();
        var circle = null;
        
        function load(){
        
            var lon;
            var lat;
        
            var zoom1 = 17 - 8;
        
            var latlng = new google.maps.LatLng(' . $settings['initialMapCoordinates'] . ');
        
             myOptions = {
              zoom: zoom1,
              center: latlng,
        //		      mapTypeId: google.maps.MapTypeId.ROADMAP,
              scaleControl: true,
              zoomControl: true,
              zoomControlOptions: {
                    position: google.maps.ControlPosition.LEFT_TOP
                },
        
              panControl: true,
draggable: 1,			  
              rotateControl: true,
//              rotateControlOptions: {
//                                position: google.maps.ControlPosition.LEFT_TOP
//                            },
              disableDoubleClickZoom: 1,

                ';
        
            if ($settings['enableStreetViewLayer']) {                
                $out .= '  streetViewControl: 1,
                            streetViewControlOptions: {
                                position: google.maps.ControlPosition.LEFT_TOP
                            },
                        ';
            }
        
            $out .= '
              scrollwheel: true
            };
        
            map = new google.maps.Map(document.getElementById("map"), myOptions);
            if (mapBounds.length > 0)
        			map.fitBounds(mapBounds);

			// 45 degree images of cities		
			map.setTilt(45);
					
            ';
            
            if ($settings['enableBicyclingLayer']) {                
                $out .= '
                var bikeLayer = new google.maps.BicyclingLayer();
                bikeLayer.setMap(map);
                ';
            }
      
            if ($settings['enableTrafficLayer']) {                
                $out .= '
                var trafficLayer = new google.maps.TrafficLayer();
                trafficLayer.setMap(map);
                ';
            }

            $out .= '

				function addMarker(location) {
				  marker = new google.maps.Marker({
					position: location,
					
					map: map
				  });
				  markersArray.push(marker);
				}
				
				function removeMarker(marker) {
					if(marker.setMap != null) marker.setMap(null);
				}
				
				function showMarker(marker) {
					 marker.setMap(map);
				}
				
					getMarkers();
		
				// panning for mobile devices
				google.maps.event.addListener(map, "click",function(event) {
				   //map.setZoom(9);
				   map.setCenter(event.latLng);
			   });
		

				} // load
				
/*
				var circle = null;
				function drawCircle(radius, lat, lon) {
					var center = new google.maps.LatLng(lat, lon);
					circle = new google.maps.Circle({
						center: center,
						radius: radius * 1000,
						strokeColor: "#FF0000",
						strokeOpacity: 0.8,
						strokeWeight: 2,
						fillColor: "#FF0000",
						fillOpacity: 0,
			//			editable: true,
						map: map
					});
		
				}
*/				
				
				
				
        </script>';
        return $out;
	 }
	 
	 
}

?>